# Resumo

- [Introdução](./intro.md)
- [Avisos](./avisos.md)
- [Programação](./programacao/index.md)
	- [Antes de Sair Programando](./programacao/antes.md)
		- [Specs Antes, Código Depois](./programacao/antes/specs-antes.md)
		- [Passos Como Comentários](./programacao/antes/passos-como-comentarios.md)
		- [Gherkin É Seu Amigo para Entender Expectativas](./programacao/antes/gherkin.md)
		- [Design Patterns São Usados Para Dar Nomes as Coisas, Não Para Soluções](./programacao/antes/patterns-nao-sao-solucoes.md)
		- [Pensar em Fluxo de Dados Ganha de Design Patterns](./programacao/antes/fluxo-de-dados.md)
		- [O Número Mágico Sete, Mais ou Menos Dois](./programacao/antes/numero-magico-sete.md)
		- [Custo Cognitivo É O Assassino do Entendimento](./programacao/antes/custo-cognitivo.md)
		- [Aprenda O Básico de Programação Funcional](./programacao/antes/programacao-funcional.md)
		- [Atalhos São Legais, Mas Apenas a Custo Prazo](./programacao/antes/entenda-atalhos.md)
		- [Debuggers São Superestimados](./programacao/antes/debuggers.md)
		- [Pense Nos Usuários](./programacao/antes/usuarios.md)
	- [Testes De Software](./programacao/testes.md)
		- [Testes Unitários São Bons, Testes de Integração São Mais Melhores](./programacao/testes/testes-de-integracao.md)
		- [Testar Toda Função Gera Código Morto](./programacao/testes/testes-codigo-morto.md)
		- [Testes Geram Uma API Melhor](./programacao/testes/testes-apis.md)
		- [Crie Testes Que Você Saiba Rodar Na Linha de Comando](./programacao/testes/testes-na-linha-de-comando.md)
		- [Boas Linguagens Tem Testes Embutidos](./programacao/testes/linguagens-com-testes.md)
	- [Documentando Seu Código](./programacao/documentacao.md)
		- [Documentação É Uma Carta de Amor Ao Seu Futuro Eu](./programacao/documentacao/documente.md)
		- [A Documentação de uma Função É o Seu Contrato](./programacao/documentacao/documentacao-e-contrato.md)
		- [Se A Documentação de uma Função Tem "E", Está Errado](./programacao/documentacao/documentacao-com-e.md)
		- [Boas Linguagens Tem Documentação Embutida](./programacao/documentacao/linguagens-com-documentacao.md)
	- [Controle de Versões](./programacao/controle-de-versao.md)
		- [Sempre Use Um Controle de Versão](./programacao/controle-de-versao/sempre-use-scv.md)
		- [Um Commit Por Alteração](./programacao/controle-de-versao/um-commit.md)
		- [Gerrit É Uma Cagada](./programacao/controle-de-versao/gerrit.md)
		- [Git-Flow É o Caminho](./programacao/controle-de-versao/git-flow.md)
	- [Organização de Projetos](./programacao/organizacao.md)
		- [Organize Seu Código por Tipo de Dado, Não Por Função](./programacao/organizacao/organizacao-de-projetos.md)
		- [Crie Bibliotecas](./programacao/organizacao/bibliotecas.md)
		- [Notas em Papel São Bem Úteis](./programacao/organizacao/notas-em-papel.md)
	- [Escrevendo Código](./programacao/programando.md)
		- [Esteja Pronto Para Jogar Código Fora](./programacao/programando/jogar-fora.md)
		- [Resolver O Futuro Gera Problemas Futuros](./programacao/programando/problemas-futuros.md)
		- [Não Use Booleanos Como Parâmetros](./programacao/programando/parametros-booleanos.md)
		- [Cuidado Com as Alterações de Interface](./programacao/programando/mudancas-de-interface.md)
		- [É Melhor Deixar A Aplicação Explodir Do Que Fazer Nada](./programacao/programando/deixe-explodir.md)
		- [Se Você Sabe Como Lidar Com O Erro, Lide](./programacao/programando/lide-com-erro.md)
		- [Tipos Dizem O Que Seus Dados São](./programacao/programando/tipos-de-dados.md)
		- [Se Os Seus Dados Tem Estrutura, Use Uma Estrutura](./programacao/programando/use-estruturas.md)
		- [Não Mexa Em Coisas Fora do Seu Projeto](./programacao/programando/fora-do-projeto.md)
		- [Resista À Tentação do Fácil](./programacao/programando/facil.md)
		- [Comece de Forma Idiota](./programacao/programando/comece-idiota.md)
		- [Sempre Use Timezones nas Datas](./programacao/programando/use-timezones.md)
		- [Sempre Use UTF-8 nas Strings](./programacao/programando/use-utf8.md)
		- [Otimização É Para Compiladores](./programacao/programando/otimizacao.md)
		- [Unidades Fazem as Coisas Mais Claras](./programacao/programando/unidades.md)
		- [Se Não Roda No Seu Computador, Está Errado](./programacao/programando/rode-localmente.md)
		- [Nada Mais Permanente Que Uma Solução Temporária](./programacao/programando/solucao-permanente.md)
	- [Fazendo As Coisas Andarem](./programacao/rodando.md)
		- [O Arquivo de Config É Seu Amigo](./programacao/rodando/arquivo-de-config.md)
		- [Opção de Linha de Comando São Esquisitas Mas Úteis](./programacao/rodando/opcoes-de-linha-de-comando.md)
		- [Não Apenas Composição de Funções, Mas Composição de Aplicações](./programando/rodando/composicao-de-aplicacoes.md)
		- [Mesmo Para Composição de Aplicações, Comece Idiota](./programacao/rodando/composicao-de-aplicacoes-idiota.md)
		- [Logs São Para Eventos, Não Interface Com o Usuário](./programacao/rodando/logs-para-eventos.md)
		- [Seja Transparente Com o Usuário](./programacao/rodando/transparencia.md)
		- [Uma Versão para Adicionar, Uma Para Remover](./programacao/rodando/adicione-e-remova.md)
		- [Aprenda a Monitorar](./programacao/rodando/monitoramento.md)
- [Comunidades e Times](./times/index.md)
	- [Uma Linguagem É Mais Que Uma Linguagem](./times/linguagens-tem-mais.md)
	- [Entenda e Afaste-se do "Cargo Cult"](./times/cargo-cult.md)
	- ["A Ferramenta Certa" Tem Sempre Algo Por Trás](./times/a-ferramenta-certa.md)
	- ["A Ferramenta Certa" É Mais Óbvia Do Que Você Pensa](./times/a-ferramenta-certa-obvia.md)
	- [Revisão de Código Não É Para Validar Estilo](./times/estilos-em-revisao-de-codigo.md)
	- [Formatadores de Código São Ok, Mas Nenhuma Bala de Prata](./times/formatador-de-codigo.md)
	- [Estilo de Código: Siga-o!](./times/estilo-de-codigo.md)
	- [... A Não Ser Que Seja o Estilo Google](./times/estilo-de-codigo-google.md)
	- [Hero Projects: Você Vai Ter Que Fazer](./times/hero-projects.md)
	- [Alterações Globais Devem Ser Discutidas com o Time](./times/discuta-com-o-time.md)
- [Pessoal](./pessoal/index.md)
	- [Empresas Procuram por Especialistas, Mas Ficam com os Generalistas](./pessoal/especialistas.md)
	- [Mantenha Uma Lista de Bugs Idiotas Que Levaram Mais de 1 Hora para Resolver](./pessoal/lista-de-bugs-idiotas.md)
	- [Quando É Hora de Parar, É Hora de Parar](./pessoal/hora-de-parar.md)
	- [Códigos de Conduta Protege](./pessoal/cdc.md)
	- [Aprenda a Dizer Não](./pessoal/diga-nao.md)
	- [Responsabilize-se Pelo Uso do Seu Código](./pessoal/responsabilize-se.md)
	- [Não Diga Que Está Pronto Quando Não Estiver](./pessoal/nao-pronto.md)
	- [Pessoas Se Irritam Com Arquitetura Porque Elas Se Importam](./pessoal/irritacao-com-arquitetura.md)
	- [Você Vai Aprender Sobre Você Na Marra](./pessoal/aprender-sobre-voce.md)
	- [Preste Atenção Como as Pessoas Reagem à Você](./pessoal/observe-reacoes.md)
	- [Não Confunda "Hero Project" com "Síndrome do Herói"](./pessoal/sindrome-do-heroi.md)
	- [Cuidado com Pessoas Tóxicas](./pessoal/pessoas-toxicas.md)
	- [Cuidado com Micro-Agressões](./pessoal/micro-agressoes.md)
	- [Pessoas Tóxicas/Agressivas Não Tem Solução -- A Menos Que Seja Você](./pessoal/solucao.md)
	- [Perceba Quando For Hora de Sair](./pessoal/sair.md)
	- [O Mundo da T.I. É Bem Pequeno](./pessoal/mundo-da-ti.md)
	- [Escrever um Blog Sobre a Sua Solução Idiota É Melhor que o Silêncio](./pessoal/blogar.md)
	- [Não Esconda Sua Solução Idiota](./pessoal/mostre-solucao-idiota.md)
	- [Mantenha Uma Lista de Coisas Que Você Não Sabe](./pessoal/coisas-que-voce-nao-sabe.md)
	- [Você Sempre Tem Tempo](./pessoal/tempo.md)
	- [Assuma Suas Merdas](./pessoal/assuma.md)
	- [Não Defenda Código Ruim](./pessoal/codigo-ruim.md)

<!-- 
vim:spelllang=pt tw=0:
-->
