# Custo Cognitivo É O Assassino do Entendimento

"[Dissonância Cognitiva](https://en.wikipedia.org/wiki/Cognitive_dissonance)" é
um nome bonito para dizer "Eu preciso lembrar duas (ou mais) coisas diferentes
e contraditórias ao mesmo tempo para entender isso". Manter essas coisas
diferentes na sua cabeça cria um custo que fica acumulando quanto mais
indiretas essas coisas são (porque você precisa manter todas elas ao mesmo
tempo).

(Aviso: Eu gosto de usar a expressão "dissonância cognitiva" para parecer
inteligente. Eu explico depois a diferença entre "dissonância cognitiva" e
"custo cognitivo".)

Para dar um exemplo (leve) de custo cognitivo, eu vou lhe mostrar o seguinte:

* Você tem uma função chamada `sum()`. Ela retorna o somatório de uma lista de
    números.
* O sistema está cheio de funções que começam com `is_`. Essas funções fazem um
    teste e retorno um valor booleano.
* Existe uma função chamada `is_even()`. Ela recebe um número e retorna True se
    o valor é par e False se o valor for ímpar.

Bem simples, certo? Uma função faz o somatório de números e outra retorna um
booleano.

Agora, o que você pensaria se visse isso, em Python:

```python
sum(is_even(x) for x in my_list)
```

Espera aí, eu não tinha dito que `sum()` faz o somatório de números? E que
`is_even()` retorna um booleano? Como é que eu somo booleanos? Qual é o
resultado esperado de "True + True + False"?

Infelizmente, isso funciona. Porque alguém, a muito tempo atrás, não achava que
booleanos era importantes o suficiente e usaram um inteiro no lugar. E todo
mundo que veio depois cometeu o mesmo erro.

Mas, para você, você vai ver uma linha que diz "somando uma lista de booleanos
retorna um número". E isso são duas coisas diferentes que você tem que, de
repente, manter em mente quando estiver lendo essa linha.

É por isso que [tipos são importantes](../programando/tipos-de-dados.md). E
custo cognitivo também está relacionado com [o número mágico
sete](./numero-magico-sete.md) porque você tem que manter duas coisas
ao mesmo tempo em mente, mas o primeiro é sobre itens relacionados, enquanto
que custo cognitivo se refere a coisas diferentes.

<!--
vim:spelllang=pt:
-->
