# Atalhos São Legais, Mas Apenas a Custo Prazo

Várias linguagens/bibliotecas/frameworks vem com alguma funcionalidade para
fazer com que você escreva menos código do que normalmente precisaria.

Mas o uso desses atalhos uma hora não vão servir para o que você precisa e aí
você vai precisar entender o que é que o atalho faz de verdade.

Frameworks e bibliotecas -- e até mesmo algumas linguagens -- vêm com "helpers"
para a maior parte das coisas com boilerplate. Ao invés de digitar 5 linhas de
código várias vezes, você usa uma função simples; ao invés de escrever a função
com 5 parâmetros, você ignora alguns dados e usa uma função com apenas um. Ou
você pode adicionar uma macro de expansão em cima da sua estrutura/classe e os
pontos faltantes vão ser automaticamente completados.

Não me entenda errado, eu acho atalhos super úteis.

Mas você precisa entender o que é que a macro/função está escondendo de você.
Porque mais cedo ou mais tarde, vai aparecer aquele caso em que o atalho não é
a solução perfeita e você precisa apenas mudar um pequeno detalhe. E aí você
vai ficar andando em círculos porque, bom, como é que diabos a macro/função faz
_aquilo_?

Eu já me dei mal com [Spring](http://spring.io/) e [Serde](https://serde.rs/')
porque eu comecei usando os atalhos sem entender o que eles faziam. E quando eu
precisei resolver um problema que o atalho não conseguia resolver sozinho, eu
tive que me aprofundar na documentação. E como eu pulei vários passos e fui
direto pro atalho, eu levei um bom tempo para realmente _entender_ o que é que
eu precisava fazer de diferente do que o que o atalho faz para resolver meu
problema. 

<!--
vim:spelllang=pt:
-->
