# Pensar em Fluxo de Dados Ganha de Design Patterns

Quando você estiver tentando encontrar uma solução para o seu problema, pense
na forma como os dados irão fluir pelo seu código.

Ao invés de focar em design patterns, uma forma melhor é pensar na forma como
o dado vão fluir -- e ser transformado -- no seu cóðigo.

Por exemplo, o usuário irá digitar um número. Você vai pegar esse número e
encontrar o registro específico no banco de dados. Essa é uma transformação --
não, não é "Eu vou pegar o número e receber uma coisa completamente diferente
baseado nesse número"; você está transformando o número num registro, usando o
banco de dados como transformação.

(Sim, eu sei, não parece óbvio de cara, mas se você tem que pensar que os dois
são representações do mesmo dado.)

A maior parte das vezes que eu fiz isso, eu consegui criar uma design mais
óbvio para minhas aplicações. Eu não pensei em quantas funções/classes seriam
necessárias para fazer essas transformações, isso foi algo que eu pensei
_depois_ de conseguir ver como os dados iriam fluir no código.

De certa forma, essa forma de pensar deixar as coisas mais simples porque você
tem uma lista de passos de transformações que você precisa fazer, de forma que
você coloca um depois do outro, descrevendo _exatamente_ o que o seu código
faz, o que previne um monte de código ruim no futuro.

<!-- 
vim:spelllang=pt:
-->
