# Gherkin É Seu Amigo para Entender Expectativas

Gherkin é um formato de arquivo para escrever testes de comportamento (BDD -
Behavior Driven Development). Mas também pode ser usado para dar a você
algumas dicas do que deve ser feito.

Então, vamos falar um pouco sobre o Gherkin:

[Gherkin](https://en.wikipedia.org/wiki/Cucumber_(software)#Gherkin_language)
é um formato de arquivo criado para o [Cucumber](https://en.wikipedia.org/wiki/Cucumber_(software)),
onde são descritos os cenários, o que há neles, quais ações o usuário/sistema
irá fazer e o qual é o resultado esperado dessas ações, em alto nível,
permitindo que pessoas sem experiência em programação possam descrever qual é
o resultado esperado de um sistema.

Embora Gherkin tenha nascido com o Cucumber, esse formato é suportado por
várias linguagens, através de bibliotecas externas.

Um arquivo Gherkin típico pode ser parecer com isso:

* **Dado que** _estado inicial do sistema_
* **Quando** _ação feita pelo usuário ou por um sistema externo_
* **Então** _estado esperado_

Ou, num formato mais concreto:

* **Dado que* o sistema está recuperando todos os tweets que o usuário deu
	"like"
* **Quando** é encontrado um tweet com um anexo
* **Então** o anexo deve ser saldo junto com o texto do tweet

Simples, não?

E porque eu estou mencionando o Gherkin?

Algumas vezes, as especificações não são a forma mais direta de informação
sobre o que é esperado do sistema, e você não consegue pensar em como
[escrever os passos necessários](./passos-como-comentarios.md). Se você está
confuso sobre o que deve escrever, perguntar para a pessoa responsável para
escrever algo parecido com o Gherkin pode lhe trazer mais informações do que
deve ser feito.

Obviamente, não vai ser completo. Pessoas tendem a esquecer situações de erro
-- como preencher o campo de nome somente com números, usar letras num campo
de idade, tweets sem nenhum texto e apenas anexos -- mas pelo menos com uma
descrição do sistema em Gherkin, você pode ter uma visão melhor do todo.

Também, você pode não gostar de escrever especificações. Tudo bem, você pode
trocar elas por Gherkin.

<!-- 
vim:spelllang=pt:
-->
