# Passos Como Comentários

Você não ver o caminho para resolver o seu problema? Escreva os passos como
comentários no seu código.

Você está lá, olhando para um arquivo vazio, se perguntando como é que vai
resolver o problema. Uma dica:

Pegue as especificações que você (ou alguém) escreveu. Quebre cada ponto num
série de passos para chegar ao resultado esperado. Você pode escrever em
qualquer linguagem, se você não quiser fazer em inglês[^1].

A partir daí, preencha os espaços entre os comentários com código.

Por exemplo, se você tiver uma especificação que diz "conecte ao servidor X e
recupere todos os dados. Salve o conteúdo num banco de dados. Lembre-se que a
API do servidor X permite que se passe um ID (o último ID visto) e você pode
usar isso para não ficar pedindo o mesmo conteúdo várias vezes". Fácil, né?

Escrevendo isso comentário, com os passos que você tem que fazer, você pode
chegar a ter algo do tipo:

```
// conectar ao servidor X
// recuperar os dados
// mandar os dados para o banco de dados
```

Ah, você esqueceu a parte do ID. Sem problemas, você adiciona esse passo no
lugar certo -- no nosso exemplo, não faz sentido conectar ao servidor antes de
ter o último ID visto, por exemplo:

```
// abrir o arquivo de configuração
// pegar o último ID visto; se o arquivo estiver vazio, não tem último ID
// conectar ao servidor X
// recuperar os dados a partir do último ID visto
// enviar os dados para o banco.
// salvar o último ID no arquivo de configuração
```

Agora ficou "fácil"[^2] : Você só precisa adicionar o código.

Se você estiver procurando por uma opção melhor, você pode transformar os
comentários em funções e, ao invés de ficar escrevendo o código entre os
comentários, você escreve a funcionalidade na função e, dessa forma, mantém
uma visão limpa do que a aplicação faz.

---

[^1]: Só porque "inglês" é a lingua franca da programação.

[^2]: Sim, eu estou sendo sarcástico.

<!-- 
vim:spelllang=pt:
-->
