# Design Patterns São Usados Para Dar Nomes as Coisas, Não Para Soluções

Infelizmente, a maior parte das vezes que eu vi design patterns sendo
aplicados, ele foram aplicados como uma forma de achar uma solução, e acabaram
forçando o problema a ser "distorcido" para caber no pattern.

Eu acredito que a grande maioria dos "vamos aplicar _esse_ design pattern"
antes que o problema seja entendi -- ou mesmo que se tenha tentando achar uma
solução -- vem como uma forma de [cargo cult](../../times/cargo-cult.md): "Nós
vimos que pessoas usaram esse pattern e resolveram o problema deles, então
vamos fazer o mesmo e resolver o nosso problema". Ou, pior: "Esse design
pattern foi criado por _pessoa famosa_, então vamos usar".

Mas a verdade é que design patterns _não_ devem ser usados como uma forma de
encontrar uma solução para qualquer problema. Você pode usar alguns deles como
base para a solução, mas você deve focar no _problema_, não no _pattern_.

"Será que o Visitor Pattern resolve isso?" é a pergunta errada. "O que devemos
usar para resolver nosso problema?" é a pergunta que realmente deve ser feita.
Uma vez que você resolveu o problema, você pode olhar e ver que é um visitor
pattern -- ou qualquer outro pattern. Se a solução não se parece com o
pattern, tudo bem, porque você _resolveu o problema_. E se o pattern
_resolveu_ seu problema... bom, parabêns, você  sabe como chamar a sua
solução.

Eu vi isso acontecer várias vezes: Pessoas tem um problema; pessoas decidem
usar um pattern; o pattern não resolve o problema (não resolve exatamente
100%, mas acima de 50%); o que acontece é que as pessoas começam a destorcer o
problema para que ele se encaixe no pattern ou, pior, começam a adicionar
camadas para transformar o problema no pattern.

<!-- 
vim:spelllang=pt:
-->
