# Specs Antes, Código Depois

"Sem requisitos ou design, programação é a arte de adicionar bugs em um
arquivo texto vazio." -- Louis Srygley

Se você não sabe o que você está tentando resolver, você não vai saber o que
programar.

Várias vezes nós temos essa sensação de "me deixa programar!" Mas sem entender
qual é o problema que tem que ser resolvido, você vai acabar escrevendo um
monte de coisas que não resolve nada -- ou, pelo menos, nada que _deveria_ ser
resolvido.

Então fica a dica: Tente fazer uma especificação simples daquilo que você quer
resolver. Tenha em mente que mesmo com as especificações, você pode ter que
[jogar código fora](../programando/jogar-fora.md), porque o seu entendimento
do problema vai aumentar conforme o projeto avança.

Sim, é um paradoxo: Você precisa saber o que escrever para saber o que
programar para evitar perder tempo resolvendo o problema errado, mas a
especificação pode estar errada, e aí você vai, _invariavelmente_, acabar
resolvendo o problema errado de qualquer forma. Então, qual o ponto de tudo
isso? O ponto é, a especificação reflete o seu entendimento do problema _num
determinado ponto_: Tudo que você (e o seu time) sabem está _lá_.

Das vezes que eu passei mais tempo olhando para meu código, me perguntando o
que fazer na sequencia, foi quando nós não tínhamos o próximo passo definido:
Eram pontos faltantes para solução, ou nós não tínhamos as estruturas de
comunicação definidas, ou algo do tipo. Normalmente, quando isso acontecia, eu
fiquei brincando no Twitter ou no Mastodon ao invés de tentar resolver o
problema. Agora, quando você se pegar perguntando isso -- "Eu não sei o que
fazer agora, eu não sei se eu terminei de resolver o problema atual" -- então
talvez seja hora de parar um pouco e falar com outras pessoas para descobrir o
que fazer.

Outro ponto sobre isso: Erik Deitrich escreveu um post sobre "Não Aprenda a
Programar - Aprenda a Automatizar" ([Don’t Learn to Code — Learn to
Automate](https://daedtech.com/dont-learn-to-code-learn-to-automate/)), que é
uma coisa que eu tenho que concordar porque a maior parte de nós, quando
estamos programado, pensamos "Eu preciso fazer isso, depois eu pego aquilo e
coloco lá, e de lá eu faço essa outra coisa". Basicamente, nós criamos
modelos de especificações na nossa mente, passo a passo, naquilo que nós
precisamos fazer -- basicamente, aquilo que precisamos automatizar. E, a
partir daí, tudo pode ficar até mais fácil, porque agora você pode pegar essa
especificação e fazer "Primeiro, eu como é que eu faço isso; Ok, entendi,
agora eu tenho que pegar o resultado daquilo e colocar lá" e assim por diante.
Você até tem um caminho para aprendizado, se você estiver iniciando a
programar.

<!-- 
vim:spelllang=pt:
-->
